#!/bin/bash

function CleanDir
{
	echo "[*] Cleaning directory $1"
	rm -rf \
		$1/.deps \
		$1/.libs \
		$1/Makefile \
		$1/Makefile.in \
		$1/*.a \
		$1/*.o \
		$1/*.lo \
		$1/*.la \
		$1/*.db \
		$1/hyperion \
		$1/configurationlexer.h \
		$1/configurationlexer.cpp \
		$1/configurationparser.h \
		$1/configurationparser.cpp \
	
	for f in $1/* ; do
		if [ -d $f ] ; then
			CleanDir $f
		fi
	done
}

function CleanTree
{
	echo "[*] Cleaning tree $1"
	rm -rf \
		$1/aclocal.m4 \
		$1/autom4te.cache \
		$1/config.* \
		$1/configure \
		$1/depcomp \
		$1/install-sh \
		$1/hyperion-*.tar.gz \
		$1/libtool \
		$1/ltmain.sh \
		$1/Makefile \
		$1/Makefile.in \
		$1/missing \
		$1/stamp-h1 \
		$1/ylwrap
	CleanDir $1
}

case $1 in
	init)
		cd hyperion
		ln -s "`pwd`/../../external/build/" external
		autoreconf --install
	;;
	make)
		cd hyperion
		make
		cp src/hyperion ../../install/
		cp src/modules/.libs/*.so ../../install/
	;;
	clean)
		rm hyperion/external
		CleanTree hyperion
		rm ../install/hyperion
		rm -f ../install/*.so
		rm -f ../install/*.db
	;;
	reinit)
		./$0 clean
		./$0 init
	;;
	*)
		echo "init|make|clean|remake|export"
		echo "Note: while $0 clean should remove everything not in the git repository,"\
		"$0 make will only prepare for the normal configure && make process"
	;;
esac