/*
	Hyperion - A network anomaly discovery system
	Copyright (C) 2011 Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "config.h"
#include "error.hpp"

#ifndef EVENTLOOP_HPP
#define EVENTLOOP_HPP

#include "configuration.hpp"
#include "database.hpp"
#include "event.hpp"
#include "modules.hpp"
#include "socket.hpp"
#include "timer.hpp"
#include "time.hpp"

class EventLoop
{
	public:
		EventLoop(Configuration *configuration, Database *database);
		virtual ~EventLoop();
		
		void Loop(Time testtime = Time::s(-1));
		
	private:
		EventLoop(const EventLoop &);
		EventLoop &operator=(const EventLoop &);
		
		Configuration *configuration;
		Database *database;
		EventManager *manager;
		Modules *modules;
		SocketModule *socketmodule;
		TimerModule *timermodule;
};

#endif
