import os
import struct

class fifotest:
	def __init__(self, rf, wf):
		self._r = rf
		self._w = wf
	
	def Read(self):
		return self._r.read(self)
	
	def ReadFormat(self, fmt):
		b = self._r.read(struct.calcsize(self, fmt))
	
	def Write(self, b):
		#This = means native endianness, so this should work so long as this
		#script is run on the same machine (or at least same endianness machine)
		#as the C code
		self._w.write(struct.pack("=H", len(b)) + b)
		#self._w.write(b)
	
	def WriteFormat(self, fmt, *vs):
		b = struct.pack(fmt, *vs)
		self._w.write(b)

def MakeFifo(filename):
	if os.path.exists(filename):
		os.unlink(filename)
	os.mkfifo(filename)

def Run(fn):
	filename = "test.fifo"
	rn = filename + ".out"
	wn = filename + ".in"
	MakeFifo(rn)
	MakeFifo(wn)
	wf = open(wn, "wb", 0)
	rf = open(rn, "rb", 0)
	f = fifotest(rf,wf)
	fn(f)
